/*
 * Copyright (C) Rei HOBARA 2007
 * 
 * Name:
 *     CompatilizedRandom.cs
 * Class:
 *     Rei.Random.CompatilizedRandom
 * Purpose:
 *     A compatilizer of Rei.Random.RandomBase with System.Random.
 * Remark:
 * History:
 *     2007/10/6 initial release.
 * 
 */

using System;

namespace Rei.Random {

    /// <summary>
    /// Rei.Random.RandomBaseSystem.Random݊ɂA_v^NXB
    /// eo֐̓́Eo͂System.RandomƓ͈͂ɂȂ܂B
    /// Rei.Random.RandomBasehNXSystem.RandomƂĎgꍇɗp܂B
    /// </summary>
    public class CompatilizedRandom : System.Random {
        private RandomBase original;

        /// <summary>
        /// rand\[XƂăA_v^NX܂B
        /// </summary>
        CompatilizedRandom( RandomBase rand ) {
            original = rand;
        }

        /// <summary>
        /// [0,Int32.MaxValue)̋[擾܂B
        /// </summary>
        public override Int32 Next() {
            uint r;
            do
                r = original.NextUInt32() & 0x7FFFFFFF;
            while (r == Int32.MaxValue);
            return (Int32)r;
        }

        /// <summary>
        /// [0,maxValue)̋[擾܂B
        /// AmaxValue=0̏ꍇ0Ԃ܂B
        /// </summary>
        public override Int32 Next( Int32 maxValue ) {
            return Next(0, maxValue);
        }

        /// <summary>
        /// [minValue,maxValue)̋[擾܂B
        /// AminValue=maxValuêƂminValueԂ܂B
        /// </summary>
        public override Int32 Next( Int32 minValue, Int32 maxValue ) {
            if (minValue > maxValue) throw new ArgumentOutOfRangeException();
            if (minValue == maxValue) return minValue;
            UInt32 range = (UInt32)((Int64)maxValue - minValue);
            UInt32 residue = (UInt32.MaxValue - range + 1) % range;// (MaxValue+1) % range łƃI[o[t[̂rangeĂB
            UInt32 r;
            do {
                r = original.NextUInt32();
            } while (r < residue);
            return (Int32)((Int64)((r - residue) % range) + minValue);
        }

        /// <summary>
        /// [0,1)̋[擾܂B
        /// </summary>
        protected override double Sample() {
            return this.Next() * 4.6566128752457969E-10;
        }

        /// <summary>
        /// oCgzɋ[i[܂B
        /// </summary>
        public override void NextBytes( byte[] buffer ) {
            original.NextBytes(buffer);
        }

    }

}